diff -Naur linux-2.6.11.8/arch/arm/Kconfig linux-2.6.x/arch/arm/Kconfig
--- linux-2.6.11.8/arch/arm/Kconfig	2009-09-06 22:49:56.000000000 +0100
+++ linux-2.6.x/arch/arm/Kconfig	2009-09-06 22:42:40.000000000 +0100
@@ -289,6 +289,14 @@
 	  
 	  refer to  <http://www.espd-inc.com/prod01-arm-samsung4510.htm>
 
+config ARCH_ACTELM7
+	bool "Actel M7"
+	help
+	  Actel M7 series are based on ARM7TDMI-S core,
+	  equipped with 20kb on-chip RAM and 1KB of on-chip Flash, 
+	  operating at up to 28MHz together with 
+	  a wide range of peripherals and external bus options.
+
 config ARCH_S3C44B0
 	bool "Samsung S3C44B0"
 	help
@@ -348,6 +356,8 @@
 
 source "arch/arm/mach-espd_4510b/Kconfig"
 
+source "arch/arm/mach-actelm7/Kconfig"
+
 source "arch/arm/mach-s3c24a0/Kconfig" 
 
 source "arch/arm/mach-p2001/Kconfig"
@@ -835,9 +845,9 @@
 
 source "drivers/parport/Kconfig"
 
-if ALIGNMENT_TRAP
+#if ALIGNMENT_TRAP
 source "drivers/mtd/Kconfig"
-endif
+#endif
 
 source "drivers/pnp/Kconfig"
 
diff -Naur linux-2.6.11.8/arch/arm/Kconfig-nommu linux-2.6.x/arch/arm/Kconfig-nommu
--- linux-2.6.11.8/arch/arm/Kconfig-nommu	2009-09-06 22:49:56.000000000 +0100
+++ linux-2.6.x/arch/arm/Kconfig-nommu	2009-09-06 22:42:40.000000000 +0100
@@ -16,6 +16,7 @@
 	default 0x0C000000 if ARCH_S3C44B0
 	default 0x00000000 if ARCH_S5C7375
 	default 0x00000000 if ARCH_ESPD_4510B
+	default 0x10000000 if ARCH_ACTELM7
 	default 0x10000000 if ARCH_S3C24A0 
 	default 0x40000000 if ARCH_P2001
 	default 0x00000000 if ARCH_INTEGRATOR
@@ -28,6 +29,7 @@
 	default 0x01000000 if ARCH_S3C44B0
 	default 0x00400000 if ARCH_S5C7375
 	default 0x00800000 if ARCH_ESPD_4510B
+	default 0x00100000 if ARCH_ACTELM7
 	default 0x04000000 if ARCH_S3C24A0 
 	default 0x04000000 if ARCH_P2001
 	default 0x08000000 if ARCH_INTEGRATOR
@@ -40,6 +42,7 @@
 	default 0x00000000 if ARCH_S3C44B0
 	default 0x08000000 if ARCH_S5C7375
 	default 0x01000000 if ARCH_ESPD_4510B
+	default 0x00000000 if ARCH_ACTELM7
 	default 0x02000000 if ARCH_P2001
 	default 0x24000000 if ARCH_INTEGRATOR
 	default 0x00400000
@@ -51,6 +54,7 @@
 	default 0x00200000 if ARCH_S3C44B0
 	default 0x00200000 if ARCH_S5C7375
 	default 0x00200000 if ARCH_ESPD_4510B
+	default 0x01000000 if ARCH_ACTELM7
 	default 0x00400000 if ARCH_P2001
 	default 0x01000000 if ARCH_INTEGRATOR
 	default 0x00400000
diff -Naur linux-2.6.11.8/arch/arm/kernel/vmlinux.lds.S linux-2.6.x/arch/arm/kernel/vmlinux.lds.S
--- linux-2.6.11.8/arch/arm/kernel/vmlinux.lds.S	2005-04-30 02:26:22.000000000 +0100
+++ linux-2.6.x/arch/arm/kernel/vmlinux.lds.S	2009-09-06 22:42:40.000000000 +0100
@@ -150,6 +150,7 @@
 		*(.bss)
 		*(COMMON)
 		_end = .;
+		_ebss = .;
 	}
 					/* Stabs debugging sections.	*/
 	.stab 0 : { *(.stab) }
diff -Naur linux-2.6.11.8/arch/arm/mach-actelm7/arch.c linux-2.6.x/arch/arm/mach-actelm7/arch.c
--- linux-2.6.11.8/arch/arm/mach-actelm7/arch.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/arch/arm/mach-actelm7/arch.c	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,45 @@
+/*
+ *  linux/arch/arm/mach-actelm7/arch.c
+ *
+ *  Architecture specific fixups.  This is where any
+ *  parameters in the params struct are fixed up, or
+ *  any additional architecture specific information
+ *  is pulled from the params struct.
+ */
+#include <linux/config.h>
+#include <linux/types.h>
+#include <linux/sched.h>
+#include <linux/interrupt.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/list.h>
+#include <linux/device.h>
+#include <linux/slab.h>
+#include <linux/string.h>
+#include <linux/sysdev.h>
+
+#include <asm/hardware.h>
+#include <asm/io.h>
+#include <asm/irq.h>
+#include <asm/setup.h>
+#include <asm/mach-types.h>
+
+#include <asm/mach/arch.h>
+#include <asm/mach/irq.h>
+#include <asm/mach/map.h>
+
+#include <linux/tty.h>
+#include <asm/elf.h>
+#include <linux/root_dev.h>
+#include <linux/initrd.h>
+
+extern void __init actelm7_init_irq(void);
+
+extern struct sys_timer actelm7_timer;
+
+MACHINE_START(ACTELM7, "Actel M7, Actel Corporation")
+	MAINTAINER("Steven taffs <steventaffs@yahoo.com>")
+	INITIRQ(actelm7_init_irq)
+	.timer	= &actelm7_timer,
+MACHINE_END
diff -Naur linux-2.6.11.8/arch/arm/mach-actelm7/head.S linux-2.6.x/arch/arm/mach-actelm7/head.S
--- linux-2.6.11.8/arch/arm/mach-actelm7/head.S	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/arch/arm/mach-actelm7/head.S	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,110 @@
+/*
+ *  linux/arch/arm/mach-actelm7/head.S
+ *
+ *  uClinux kernel startup code for actelm7
+ *  which has no proper bootloader for linux startup
+ *  because of XIP.
+ */
+#include <linux/config.h>
+#include <linux/linkage.h>
+#include <linux/init.h>
+
+#include <asm/assembler.h>
+#include <asm/mach-types.h>
+#include <asm/procinfo.h>
+#include <asm/ptrace.h>
+#include <asm/mach/arch.h>
+#include <asm/arch/hardware.h>
+/*
+ * Kernel startup entry point.
+ */
+	__INIT
+	.type	stext, #function			/*type stext is a function symbol*/
+ENTRY(stext)						/*tell the compiler that stext section is function */
+
+	mov	r12, r0						
+	mov	r0, #PSR_F_BIT | PSR_I_BIT | MODE_SVC	/* make sure svc mode */
+	msr	cpsr_c, r0				/* and all irqs disabled */ 
+
+/* Do basic initialization */
+
+	adr	r3, __LC0_init_data
+	ldmia	r3!, {r4, r5, r6, r7}
+
+    	cmp	r4, r5					@ Copy data segment if needed
+1:	cmpne	r5, r6
+	ldrne	fp, [r4], #4
+	strne	fp, [r5], #4
+	bne	1b
+
+	mov	fp, #0					@ Clear BSS (and zero fp)
+1:	cmp	r6, r7
+	strcc	fp, [r6],#4
+	bcc	1b
+
+  /*  Pretend we know what our processor code is (for arm_id)   */
+
+	ldmia	r3, {r6, r9, sp}
+	ldr	r2, ACTELM7_PROCESSOR_TYPE
+
+	str     r2, [r6]				/* store processor_type in processor_id address */
+	ldr     r2, ACTELM7_MACH_TYPE				
+	str     r2, [r9]				/* store MACH_TYPE in __machine_arch_type address */
+
+        mov fp, #0					/*clear frame reg (r11 it looks like)*/
+	
+	
+/*	ldr	r4, UART0_LCR	
+	mov	r5, #0x83
+	str	r5,[r4]
+		
+	ldr	r4, UART0_DLR
+	mov	r5, #0x09
+	str	r5,[r4]
+	
+	ldr	r4, UART0_DMR
+	mov	r5, #0x00
+	str	r5,[r4]	
+
+	ldr	r4, UART0_LCR
+	mov	r5, #0x03
+	str	r5,[r4]
+	
+	ldr	r4, UART0_REC
+	mov	r5, #0x31
+	str	r5,[r4]			*/
+	
+	
+  	b	start_kernel				/*jump to start of kernel */
+        
+
+.type	__LC0_init_data, %object
+__LC0_init_data:
+	.long	__data_loc		@ r4
+	.long	__data_start		@ r5
+	.long	__bss_start		@ r6
+	.long	_end			@ r7
+	.long	processor_id		@ r4
+	.long   __machine_arch_type	@ r5
+	.long	init_thread_union+8192	@ sp
+
+	.align	8
+	
+ACTELM7_PROCESSOR_TYPE:
+	.long	0x22000000
+ACTELM7_MACH_TYPE:
+	.long	MACH_TYPE_ACTELM7
+
+/*UART0_DLR:
+	.long  0x22000000
+UART0_DMR:
+	.long  0x22000004
+UART0_LCR:
+	.long  0x2200000C
+UART0_REC:
+	.long  0x22000000 */
+
+#include "../kernel/head-common.S"
+
+
+
diff -Naur linux-2.6.11.8/arch/arm/mach-actelm7/irq.c linux-2.6.x/arch/arm/mach-actelm7/irq.c
--- linux-2.6.11.8/arch/arm/mach-actelm7/irq.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/arch/arm/mach-actelm7/irq.c	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,122 @@
+/*
+ *  linux/arch/arm/mach-actelm7/irq.c
+ *
+ */
+#include <linux/config.h>
+#include <linux/types.h>
+#include <linux/sched.h>
+#include <linux/interrupt.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/list.h>
+#include <linux/device.h>
+#include <linux/slab.h>
+#include <linux/string.h>
+#include <linux/sysdev.h>
+
+#include <asm/hardware.h>
+#include <asm/io.h>
+#include <asm/irq.h>
+#include <asm/setup.h>
+#include <asm/mach-types.h>
+
+#include <asm/mach/arch.h>
+#include <asm/mach/irq.h>
+#include <asm/mach/map.h>
+
+void __inline__ actelm7_mask_irq(unsigned int irq)
+{
+	IRQEnableClear = 1 << irq;
+}
+
+void __inline__ actelm7_unmask_irq(unsigned int irq)
+{
+	IRQEnable |= 1 << irq;
+}
+
+/* Clear pending bit */
+void __inline__ actelm7_clear_pb(unsigned int irq)
+{
+	/* we dont have external interupts at the moment*/
+	return;
+}
+
+void __inline__ actelm7_mask_ack_irq(unsigned int irq)
+{
+
+	actelm7_clear_pb(irq);
+	actelm7_mask_irq(irq);
+}
+
+
+/* YOU CAN CHANGE THIS ROUTINE FOR SPEED UP */
+__inline__ unsigned int fixup_irq (int irq )
+{
+	actelm7_clear_pb(irq);
+	return(irq);
+}
+
+static struct irqchip actelm7_chip = {
+	//set the pointers so ack, mask & unmask functions can be used
+	.ack	= actelm7_mask_ack_irq,
+	.mask	= actelm7_mask_irq,
+	.unmask = actelm7_unmask_irq,
+};
+
+#ifdef CONFIG_PM
+static unsigned long ic_irq_enable;
+
+static int irq_suspend(struct sys_device *dev, u32 state)
+{
+	return 0;
+}
+
+static int irq_resume(struct sys_device *dev)
+{
+	/* disable all irq sources */
+	return 0;
+}
+#else
+#define irq_suspend NULL
+#define irq_resume NULL
+#endif
+
+static struct sysdev_class irq_class = {
+	set_kset_name("irq"),
+	.suspend	= irq_suspend,
+	.resume		= irq_resume,
+};
+
+static struct sys_device irq_device = {
+	.id	= 0,
+	.cls	= &irq_class,
+};
+
+static int __init irq_init_sysfs(void)
+{
+	int ret = sysdev_class_register(&irq_class);
+	if (ret == 0)
+		ret = sysdev_register(&irq_device);
+	return ret;
+}
+
+device_initcall(irq_init_sysfs);
+
+void __init actelm7_init_irq(void)
+{
+        int irq;
+
+	for (irq = 0; irq < NR_IRQS; irq++) {
+		//register each irq in turn with the kernel
+		set_irq_chip(irq, &actelm7_chip);
+		//get a handle for each irq
+		set_irq_handler(irq, do_level_IRQ);
+		
+		set_irq_flags(irq, IRQF_VALID | IRQF_PROBE);
+	}
+
+	/* mask and disable all further interrupts */
+	IRQEnableClear = 0xFF;
+}
+
diff -Naur linux-2.6.11.8/arch/arm/mach-actelm7/Kconfig linux-2.6.x/arch/arm/mach-actelm7/Kconfig
--- linux-2.6.11.8/arch/arm/mach-actelm7/Kconfig	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/arch/arm/mach-actelm7/Kconfig	2009-09-12 17:40:58.000000000 +0100
@@ -0,0 +1,42 @@
+#       linux/arch/arm/mach-actelm7/Kconfig	
+#
+
+
+menu "Actel M7 Options"
+	depends on ARCH_ACTELM7
+
+config ARCH_SUPPORTS_BIG_ENDIAN
+    bool "Default Big Endian mode"
+    default n
+	help
+	Actel M7 core supports LITTLE-ENDIAN only,
+	both for CPU core and the external memory access.
+
+config ActelM7_Fosc
+    int	"Oscillator Frequency"
+    default 20000000
+    help
+	Oscillator frequency. The default is 20MHz. 
+	Change it according to your board.
+	
+config ARM_CLK
+	int 'Arm Core Clock'
+	default 20000000
+	help
+	CPU core clock frequency. The default is 20MHz.
+	Change it according to your application needs.
+
+config SKIP_DUMP_CPU_INFO
+	bool
+	default	y 
+	help
+	Actel M7 (ARM7TDMI) core has no cache and does not support cache size
+	recognition instructions which uses MMU features.
+
+config REMAP_VECTORS_TO_RAM
+	bool "Remap Vectors to ram"
+	default y
+	help
+	Actel M7 suppports ROM and RAM remap function. 
+
+endmenu
diff -Naur linux-2.6.11.8/arch/arm/mach-actelm7/Makefile linux-2.6.x/arch/arm/mach-actelm7/Makefile
--- linux-2.6.11.8/arch/arm/mach-actelm7/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/arch/arm/mach-actelm7/Makefile	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,7 @@
+#
+# Makefile for the linux kernel.
+#
+
+# Object file lists.
+
+obj-y		+= arch.o irq.o time.o
diff -Naur linux-2.6.11.8/arch/arm/mach-actelm7/time.c linux-2.6.x/arch/arm/mach-actelm7/time.c
--- linux-2.6.11.8/arch/arm/mach-actelm7/time.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/arch/arm/mach-actelm7/time.c	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,80 @@
+/*
+ *  linux/arch/arm/mach-actelm7/time.c
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <asm/system.h>
+#include <asm/leds.h>
+#include <asm/mach-types.h>
+
+#include <asm/io.h>
+#include <asm/irq.h>
+#include <asm/hardware.h>
+#include <asm/mach/time.h>
+#include <asm/arch/time.h>
+
+extern void	actelm7_unmask_irq(unsigned int);
+
+unsigned long actelm7_gettimeoffset (void)
+{
+    return ((INIT_VALUE - T0_VALUE) / CLOCKS_PER_USEC);
+}
+
+static irqreturn_t
+actelm7_timer_interrupt(int irq, void *dev_id, struct pt_regs *regs)
+{
+
+    if (!(T0_MIS & 0x01)) return IRQ_NONE;
+
+    timer_tick(regs);
+
+    T0_INT_CLR = 0x01;	/* reset interrupt */
+    return IRQ_HANDLED;
+}
+
+static struct irqaction actelm7_timer_irq = {
+        .name           = "actelm7 Timer Tick",
+        .flags          = SA_INTERRUPT,
+        .handler        = actelm7_timer_interrupt
+};
+
+/*
+ * Set up timer interrupt, and return the current time in seconds.
+ */
+
+void __init  actelm7_time_init (void)
+{
+	
+	// disable timer 0 
+	T0_TCR = 0x00;
+	
+	/* initialize the timer period to interrupt every 10ms*/
+	T0_TLR = INIT_VALUE;
+
+	//set the prescale to its lowest value which is divide by 2
+	T0_PR = PRESCALE_COUNTER_INIT_VALUE;
+
+	/*
+	 * @todo do those really need to be function pointers ?
+	 */
+	actelm7_timer_irq.handler = actelm7_timer_interrupt;
+
+	/* set up the interrupt vevtor for timer 0 match */
+	setup_irq(ACTELM7_INTERRUPT_TIMER0, &actelm7_timer_irq);
+	
+	/* enable the timer IRQ */
+	actelm7_unmask_irq(ACTELM7_INTERRUPT_TIMER0);
+
+	/* let timer 0 run... */
+	T0_INT_CLR = 0x01;    /* reset timer0 interrupts*/
+	T0_TCR = 0x03;	      /* enable timer counter and timer interrupt */
+}
+
+struct sys_timer actelm7_timer = {
+	.init		= actelm7_time_init,
+	.offset		= actelm7_gettimeoffset,
+};
